#ifndef qbLexerHH
#define qbLexerHH

#define YY_LEXFUNAME lex_get_token
#define YY_DECL int YY_LEXFUNAME()
extern YY_DECL;

struct LexLocation
{
    int line;
    int col;
    std::string filename;

public:    
    const std::string stringify() const;
};

void yyStartFile(FILE *fp, const char *name);
void yyEndFile(void);
void yyerror(const std::string& msg, const LexLocation& loc);
void yyerror(const std::string& msg);
const LexLocation& yyGetLocation();

extern struct LexerResult
{
    std::string str;
    long double number;
    char numtype;
} yylval;

#include "tokens.hh"
#endif
